/* Written by Dmitrij Schlesinger (2012),
 * http://wwwpub.zih.tu-dresden.de/~ds24/rtsegm/rtsegm.html
*/

#ifndef __RTSEGM_SEGM
#define __RTSEGM_SEGM

#include "ed_thread.h"

// This class implements Gibbs Sampling for segmentations.
class Rtsegm_segm : public ed_thread {
public:
    Rtsegm_segm(int height, int width, double potts, double step);
    virtual ~Rtsegm_segm();

    // threading management
    bool stop_me;
    void run();
    void reset();
    int it_count;

    // model data
    int width, height;
    double potts, potts2, step;

    // current (sampled) segmentation
    int *lab;

    // marginal label probabilities
    double *marg;

    // inputs from the appearance model "Rtsegm_gauss"
    // Gaussian weights
    double *weights;
    // the field of Gaussian numbers (sampled by "Rtsegm_gauss")
    int *glab;

    // input from the appearance model "Rtsegm_shape"
    // -- unary potentials for the foregroung at each pixel
    double *qsh;

    // lookup table
    unsigned short int *table;
};

#endif
